package ds4eti2018_1S.modele;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.Map;

public class Jeu {
	public static final Map<Case, Integer> stats = createMap();
	public static final int MAX_JOUEURS = 4;
	
	private Plateau plateau;
	private int nbJoueurs = 1;
	private int joueur = 1;
	
	public Jeu(int x, int y, int nbJoueurs){
		plateau = new Plateau(x,y);
		
		if(nbJoueurs>0 && nbJoueurs<Jeu.MAX_JOUEURS){
			this.nbJoueurs = nbJoueurs;
		}
	}
	
	public Jeu(int x, int y){this(x,y,1);}
	
	public Jeu(int nbJoueurs){this(8,10,nbJoueurs);}
	
	public Jeu(){this(8,10,1);}
	
	public ArrayList<ArrayList<Case>> getCases() {return plateau.getCases();}
	public int getJoueur() {return joueur;}
	
    private static Map<Case, Integer> createMap()
    {
        Map<Case,Integer> myMap = new LinkedHashMap<Case,Integer>();
        myMap.put(new Demine(), 5);
        myMap.put(new Mine(), 20);
        myMap.put(new Info(), 100);
        return myMap;
    }
    
    public Plateau getPlateau(){return plateau;}
    public void nextJoueur(){joueur=(joueur%nbJoueurs) +1;}
    public void rejouer(){plateau=new Plateau();}
}
